# BreedingSchemeLanguage
R/package "BreedingSchemeLanguage"
It is difficult for plant breeders to determine an optimal breeding strategy given that the problem involves many factors, such as target trait genetic architecture and breeding resource availability. There are many possible breeding schemes for each breeding program. Although simulation study may be useful to help choose a better (or the best) breeding scheme, it is difficult for breeders to take the first step in conducting breeding simulation because of the complexity of building a simulation platform or even using existing simulation tools. We present here a simple and flexible simulation platform, the breeding scheme language (BSL). This simulation platform works in the statistical computing environment R. Users define their target species, trait genetic architectures, and breeding schemes by writing simple, self- explanatory scripts. We believe the BSL will be useful for breeders to evaluate breeding schemes and to choose an optimal breeding strategy among a number of possible ones, as well as for training plant breeders.
A full manual is available at
https://github.com/jeanlucj/BreedingSchemeLanguage/blob/master/inst/Manual.pdf